Main:
        wdr

;****************************************     ******************************
        clr     Temp                    ; ,    ,     ADC_SAMPLING.
        cpse    Temp, rCh1OffTime       ;     ,        .
        sbr     rOutChannels, 1<<bChannel1
        cpse    Temp, rCh2OffTime
        sbr     rOutChannels, 1<<bChannel2

        ldi     ZL, LOW(cADCSamplesCount); 16-    
        ldi     ZH, HIGH(cADCSamplesCount);   .
        clr     rTotalVoltage1_3        ;    .
        clr     rTotalVoltage2_3        ;    .
        ldi     Temp, 255

PhaseDetect:                            ;  .
        mov     Tmp, Temp               ;   .
        in      Temp, ADCH              ;      ,
        cpc     Temp, Tmp               ;       .
        brlo    PhaseDetect             ;     .

        out     pMainOut, rOutChannels  ;    ,      .
        clr     Tmp                     ;  Tmp,        .

;**************************************** *************************************************************
ADCSampling:
        mul     Temp, Temp              ;   .

        cp      rTotalVoltage1_3, rCh1OffTime;     ,
        brlo    PC+4
        cbr     rOutChannels, 1<<bChannel1;  ,
        nop                             ;    ADCSampling ( 
        rjmp    PC+4                    ; ),     .
        add     rTotalVoltage1_1, R0    ;      ,
        adc     rTotalVoltage1_2, R1    ;    
        adc     rTotalVoltage1_3, Tmp   ;   .

        cp      rTotalVoltage2_3, rCh2OffTime
        brlo    PC+4
        cbr     rOutChannels, 1<<bChannel2
        nop
        rjmp    PC+4
        add     rTotalVoltage2_1, R0
        adc     rTotalVoltage2_2, R1
        adc     rTotalVoltage2_3, Tmp

        out     pMainOut, rOutChannels  ;     ,        .

        sbiw    ZH:ZL, 1                ;       ,
        breq    ADCExit                 ; .

        in      Temp, ADCH              ;    .      8  .
        rjmp    ADCSampling

ADCExit:
        cbr     rOutChannels, (1<<bChannel1)+(1<<bChannel2);   
        out     pMainOut, rOutChannels  ;    .
        clr     rCh1OffTime
        clr     rCh2OffTime

;****************************************     **************************************
        sbrs    reSystemBits, ebOwnersAtHome;      ()
        rjmp    Channel1Processing
        lds     Temp, mOwnersAtHomeSeconds; 10     .
        dec     Temp
        sts     mOwnersAtHomeSeconds, Temp
        brne    ExitOwnersAtHome
        ldi     Temp, 100
;ldi     Temp, 5 ;    
        sts     mOwnersAtHomeSeconds, Temp
        lds     Temp, mOwnersAtHomeMinutes
        dec     Temp
        sts     mOwnersAtHomeMinutes, Temp
        brne    ExitOwnersAtHome
        ldi     Temp, 60
        sts     mOwnersAtHomeMinutes, Temp
        lds     Temp, mOwnersAtHomeSharedCell
        dec     Temp
        sts     mOwnersAtHomeSharedCell, Temp
        brne    ExitOwnersAtHome        ;     ,

        sbrc    rBit1, bIsChannel1On    ; ,
        rjmp    OwnersAtHomeToOffState  ;   ,
        sbr     rBit1, (1<<bSoftTurnCh1)+(1<<bSoftTurnCh2)+(1<<bIsChannel1On)+(1<<bIsChannel2On)+(1<<bBrightVectorCh1)+(1<<bBrightVectorCh2)
        sbr     reSystemBits, (1<<ebPowerStateCh1)+(1<<ebPowerStateCh2);      ,      .
        lds     Temp, meOwnersAtHomeOnPeriod;        ,
        sbrs    reUserBits1, ebRandomOAH
        rjmp    OwnersAtHomeSharedCellWrite;         .
        rcall   RandomNumber8bit        ; ,     .
        cpi     Temp, cMinBrightOAH     ;     cMinBrightOAH ( 25%   ),
        brsh    PC+2
        ldi     Temp, cMinBrightOAH     ;   cMinBrightOAH.
;ldi    Temp, 150;      ,    
        sts     meOwnersAtHomeBright, Temp
        rcall   RandomNumber8bit        ;        .
        cpi     Temp, (cMaxDurationOAH + 1);    (cMaxDurationRndOAH + 1) (240 ),
        brlo    PC+2
        ldi     Temp, cMaxDurationOAH   ;   cMaxDurationRndOAH.
;ldi    Temp, 4;        
        rjmp    OwnersAtHomeSharedCellWrite;        .

  OwnersAtHomeToOffState:
        lds     Temp, meOwnersAtHomeOffPeriod;
        sbrs    reUserBits1, ebRandomOAH;    \    ,
        rjmp    OwnersAtHomeSetOffState
        rcall   RandomNumber8bit        ;      .
        cpi     Temp, (cMaxDurationOAH + 1);    (cMaxDurationRndOAH + 1) (240 ),
        brlo    PC+2
        ldi     Temp, cMaxDurationOAH   ;   cMaxDurationRndOAH.
;ldi    Temp, 4;        

  OwnersAtHomeSetOffState:
        cbr     rBit1, (1<<bIsChannel1On)+(1<<bIsChannel2On);           
        sbr     rBit1, (1<<bSoftTurnCh1)+(1<<bSoftTurnCh2);    .

  OwnersAtHomeSharedCellWrite:
        sts     mOwnersAtHomeSharedCell, Temp;         .
  ExitOwnersAtHome:

;****************************************  *********************************************************
Channel1Processing:
        sbrs    rBit1, bSoftTurnCh1     ;  ,   
        rjmp    CheckButton1            ;   .
        sbrs    rBit1, bIsChannel1On    ;  ,
        rjmp    SoftTurnOffCh1          ;   .

        lds     Temp, meOwnersAtHomeBright;     ,
        sbrc    reSystemBits, ebOwnersAtHome
        rjmp    CompareBrightnessCh1
        lds     Temp, meLastBright1_1   ;    
        sbrc    reSystemBits, ebChannel1Mode
        lds     Temp, meLastBright1_2   ;  
CompareBrightnessCh1:
        cp      Temp, rBrightnessCh1    ;      ,
        brne    SoftTurnOnCh1           ;        (  )   (    ).

SoftTurnOnCh1Completed:
        cbr     rBit1, 1<<bSoftTurnCh1  ;   ,    ,
        sbr     reSystemBits, 1<<ebPowerStateCh1;   ,
        ldi     rButton1HoldTime, 255   ;     .
        lds     Temp, meBrightnessMaxCh1;  
        cp      rBrightnessCh1, Temp    ;    ,
        brlo    PC+2
        cbr     rBit1, 1<<bBrightVectorCh1;       .
        rjmp    GoOutCh1                ;          .

SoftTurnOnCh1:                          ;     .
        lds     Temp, meTurnOnSpeedMode1Ch1;   ,   
        sbrc    reSystemBits, ebChannel1Mode
        lds     Temp, meTurnOnSpeedMode2Ch1;  .
        inc     rSoftTurnSpeedCh1       ;  ,    .
        cp      Temp, rSoftTurnSpeedCh1 ;        ,
        brne    ExitSoftTurnOnCh1       ;   ,    .
        clr     rSoftTurnSpeedCh1       ; ,   ,
        inc     rBrightnessCh1          ;     .
  ExitSoftTurnOnCh1:
        rjmp    GoOutCh1                ;      .

SoftTurnOffCh1:                         ;     .
        cbr     reSystemBits, 1<<ebPowerStateCh1;    (            ).
        sbrs    rBit1, bTurnOffStartedCh1;        ,    rSoftOffBrightCh1.
        clr     rSoftOffBrightCh1       ;    ,     .
        cp      rBrightnessCh1, rSoftOffBrightCh1;    
        breq    SoftTurnOffCh1Completed ;  ,

        lds     Temp, meTurnOffSpeedMode1Ch1
        sbrc    reSystemBits, ebChannel1Mode
        lds     Temp, meTurnOffSpeedMode2Ch1
        inc     rSoftTurnSpeedCh1
        cp      Temp, rSoftTurnSpeedCh1
        brne    ExitSoftTurnOffCh1
        clr     rSoftTurnSpeedCh1
        dec     rBrightnessCh1          ;     ,    (  SoftTurnOnCh1:).
  ExitSoftTurnOffCh1:
        rjmp    GoOutCh1

SoftTurnOffCh1Completed:                ;     ,
        cbr     rBit1, 1<<bSoftTurnCh1  ;   .
        sbrc    rBit1, bTurnOffStartedCh1;  ,
        sbr     rBit1, 1<<bIsChannel1On  ;   .
        ldi     rButton1HoldTime, 255   ;     .
        rjmp    GoOutCh1

CheckButton1:                           ;    .
        sbic    pKeyboardIn, sbChannel1 ;  , :
        rjmp    Button1IsOff

        ldi     Temp, 255               ;1)   (2,5 .)   
        sts     mSaveBrightDelayCh1, Temp;     eeprom;

        rcall   ResetAutoOffTimerCh1    ;2)      ;
                                        ;3)          .
        cpi     rButton1HoldTime, cButtonOnHoldSense;   ,   ,
        breq    Button1OnHold           ;    .
        cpi     rButton1HoldTime, 255   ;      (255),
        breq    PC+2                    ;    -      .
        inc     rButton1HoldTime        ;                  ,      .
        rjmp    IsChannel1On

Button1OnHold:
        sbrc    rBit1, bTurnOffStartedCh1;        ,
        rjmp    RestoreBrightnessCh1    ;   .
        sbrc    rBit1, bIsChannel1On    ;    ,     
        rjmp    ChangeBrightnessCh1     ;      .

        sbic    pKeyboardIn, sbChannel2 ;      
        rjmp    TurnCh1InSecondMode
        mov     Temp, rBit1             ;  
        cbr     Temp, (1<<bBrightVectorCh1)+(1<<bBrightVectorCh2); ,
        brne    TurnCh1InSecondMode
        sbr     reSystemBits, (1<<ebOwnersAtHome)+(1<<ebPowerStateCh1)+(1<<ebPowerStateCh2);     .
        rcall   OwnersAtHomeTimerTrigger;          .
        rjmp    Channel2Processing

TurnCh1InSecondMode:
        sbr     reSystemBits, 1<<ebChannel1Mode;              .
        cbr     reSystemBits, 1<<ebOwnersAtHome;    .
        rjmp    TurnCh1On

RestoreBrightnessCh1:                   ; .
        rcall   ResetAutoOffTimerCh1    ;    (  ).
        cbr     rBit1, 1<<bTurnOffStartedCh1;   .
        sbr     reSystemBits, 1<<ebPowerStateCh1;   .
        sbr     rBit1, 1<<bSoftTurnCh1  ;  ,     .
        rjmp    GoOutCh1

ChangeBrightnessCh1:
        sbrc    reSystemBits, ebOwnersAtHome;        .
        rjmp    GoOutCh1
        cp      reBrightChangeSpeedCh1, rBrightCounterCh1;          -,
        breq    BrightReadyToChangeCh1  ;    , ,   .
        inc     rBrightCounterCh1       ;   -.
        rjmp    IsChannel1On

BrightReadyToChangeCh1:
        clr     rBrightCounterCh1       ; -     .
        sbrc    rBit1, bBrightVectorCh1 ;  ,   ,
        rjmp    IncreaseBrightnessCh1   ; - .

DecreaseBrightnessCh1:
        lds     Temp, meBrightnessMinCh1
        cp      Temp, rBrightnessCh1
        brsh    MinBrightnessReachedCh1 ;    ,
        dec     rBrightnessCh1          ;    .
        rjmp    GoOutCh1
  MinBrightnessReachedCh1:              ;   ,      , - 
        mov     rBrightCounterCh1, reBrightChangeSpeedCh1;           .
        lds     Temp, mBrightMinCounterCh1;   ,
        dec     Temp                    ;    
        breq    BrightMinTimeoutIsUpCh1 ;    ,
        sts     mBrightMinCounterCh1, Temp;        ,
        rjmp    GoOutCh1                ;   .
  BrightMinTimeoutIsUpCh1:
        lds     Temp, meMinBrightDelayCh1;     ,
        sts     mBrightMinCounterCh1, Temp;   ,
        sbr     rBit1, 1<<bBrightVectorCh1;     ,
        clr     rBrightCounterCh1       ;   -   .
        rjmp    GoOutCh1

IncreaseBrightnessCh1:
        lds     Temp, meBrightnessMaxCh1
        cp      rBrightnessCh1, Temp
        brsh    MaxBrightnessReachedCh1
        inc     rBrightnessCh1
        rjmp    GoOutCh1
  MaxBrightnessReachedCh1:
        mov     rBrightCounterCh1, reBrightChangeSpeedCh1
        lds     Temp, mBrightMaxCounterCh1
        dec     Temp
        breq    BrightMaxTimeoutIsUpCh1
        sts     mBrightMaxCounterCh1, Temp
        rjmp    GoOutCh1
  BrightMaxTimeoutIsUpCh1:
        lds     Temp, meMaxBrightDelayCh1
        sts     mBrightMaxCounterCh1, Temp
        cbr     rBit1, 1<<bBrightVectorCh1
        clr     rBrightCounterCh1
        rjmp    GoOutCh1

Button1IsOff:                           ;  ,     .
        cpi     rButton1HoldTime, 255   ;        (255),
        brne    PC+2                    ;         ,
        ldi     rButton1HoldTime, 0     ;      ,    .
        cpi     rButton1HoldTime, 0     ;     ,
        breq    IsChannel1On            ;    .
        cpi     rButton1HoldTime, cButtonOnHoldSense;     (..     ),
        ldi     rButton1HoldTime, 0     ;   ( clr   , ..     SREG),
        breq    HoldButton1             ;  ,      

ClickButton1:                           ; .
        sbrc    rBit1, bIsChannel1On    ;   (bIsChannel1On=0)
        rjmp    TurnCh1Off              ;   .
        cbr     reSystemBits, (1<<ebChannel1Mode)+(1<<ebOwnersAtHome);  ,
        rjmp    TurnCh1On               ;      .     .

HoldButton1:                            ;   ,
        lds     Temp, meMinBrightDelayCh1;  
        sts     mBrightMinCounterCh1, Temp;       .
        lds     Temp, meMaxBrightDelayCh1;  
        sts     mBrightMaxCounterCh1, Temp;    .

        sbrc    reUserBits1, ebBrightDirModeCh1; ebBrightDirModeCh1=1 
        rjmp    InvertBrightVectorCh1   ;   ,          .
        lds     Temp, meBrightnessMinCh1; ebBrightDirModeCh1=0
        cp      rBrightnessCh1, Temp    ;         ,
        breq    InvertBrightVectorCh1   ;        
        lds     Temp, meBrightnessMaxCh1;  .     
        cp      rBrightnessCh1, Temp    ;     
        breq    InvertBrightVectorCh1   ;   .
        rjmp    IsChannel1On

InvertBrightVectorCh1:                  ;     .
        mov     Temp,   rBit1
        cbr     rBit1, 1<<bBrightVectorCh1
        sbrs    Temp, bBrightVectorCh1
        sbr     rBit1, 1<<bBrightVectorCh1
        rjmp    IsChannel1On

TurnCh1On:
        sbr     rBit1, (1<<bIsChannel1On)+(1<<bSoftTurnCh1)+(1<<bBrightVectorCh1);      ,  ,      .
        clr     rBrightnessCh1           ; ,   .
        rjmp    Channel2Processing

TurnCh1Off:
        sbrs    reSystemBits, ebOwnersAtHome;  
        rjmp    OwnersAtHomeNotSetCh1
        cbr     rBit1, (1<<bIsChannel1On)+(1<<bIsChannel2On);   
        sbr     rBit1, (1<<bSoftTurnCh1)+(1<<bSoftTurnCh2);  ,
        cbr     reSystemBits, (1<<ebOwnersAtHome)+(1<<ebPowerStateCh1)+(1<<ebPowerStateCh2);   .
        rjmp    GoOutCh1
  OwnersAtHomeNotSetCh1:
        cbr     rBit1, (1<<bIsChannel1On)+(1<<bTurnOffStartedCh1);     .
        sbr     rBit1, 1<<bSoftTurnCh1
        rjmp    GoOutCh1

IsChannel1On:                           ;    ,  
        sbrs    rBit1, bIsChannel1On    ;      /.
        rjmp    Channel2Processing

        sbrc    reSystemBits, ebOwnersAtHome;      
        rjmp    GoOutCh1                ;(    ).

        lds     Temp, mSaveBrightDelayCh1
        dec     Temp                     ;   .
        sts     mSaveBrightDelayCh1, Temp
        brne    ExitSaveBrightDelayCh1  ;     (2,5 .),        eeprom.
        sbrc    rBit1, bTurnOffStartedCh1;      ,
        rjmp    ExitSaveBrightDelayCh1  ;  .
        sbrc    reSystemBits, ebChannel1Mode
        rjmp    SaveBrightnessMode2Ch1
        sbrc    reUserBits2, ebSaveBrightM1Ch1;   
        sts     meLastBright1_1, rBrightnessCh1
        rjmp    ExitSaveBrightDelayCh1  ;    .
SaveBrightnessMode2Ch1:
        sbrc    reUserBits2, ebSaveBrightM2Ch1
        sts     meLastBright1_2, rBrightnessCh1
  ExitSaveBrightDelayCh1:

        rcall   TurnOffTimeoutCh1      ;-      brne ( 64 )    .

GoOutCh1:
        ldi     ZH, HIGH(2*BrightnessTable)
        ldi     ZL, LOW(2*BrightnessTable)
        add     ZL, rBrightnessCh1      ;  rBrightness   
        ldi     Temp, 0                 ;  .
        adc     ZH, Temp
        lpm     rCh1OffTime, Z          ;   rCh1OffTime         .


;****************************************  *********************************************************
Channel2Processing:
        sbrs    rBit1, bSoftTurnCh2
        rjmp    CheckButton2
        sbrs    rBit1, bIsChannel2On
        rjmp    SoftTurnOffCh2

        lds     Temp, meOwnersAtHomeBright
        sbrc    reSystemBits, ebOwnersAtHome
        rjmp    CompareBrightnessCh2
        lds     Temp, meLastBright2_1
        sbrc    reSystemBits, ebChannel2Mode
        lds     Temp, meLastBright2_2
CompareBrightnessCh2:
        cp      Temp, rBrightnessCh2
        brne    SoftTurnOnCh2

SoftTurnOnCh2Completed:
        cbr     rBit1, 1<<bSoftTurnCh2
        sbr     reSystemBits, 1<<ebPowerStateCh2
        ldi     rButton2HoldTime, 255
        lds     Temp, meBrightnessMaxCh2
        cp      rBrightnessCh2, Temp
        brlo    PC+2
        cbr     rBit1, 1<<bBrightVectorCh2
        rjmp    GoOutCh2

SoftTurnOnCh2:
        lds     Temp, meTurnOnSpeedMode1Ch2
        sbrc    reSystemBits, ebChannel2Mode
        lds     Temp, meTurnOnSpeedMode2Ch2
        inc     rSoftTurnSpeedCh2
        cp      Temp, rSoftTurnSpeedCh2
        brne    ExitSoftTurnOnCh2
        clr     rSoftTurnSpeedCh2
        inc     rBrightnessCh2
  ExitSoftTurnOnCh2:
        rjmp    GoOutCh2

SoftTurnOffCh2:
        cbr     reSystemBits, 1<<ebPowerStateCh2
        sbrs    rBit1, bTurnOffStartedCh2
        clr     rSoftOffBrightCh2
        cp      rBrightnessCh2, rSoftOffBrightCh2
        breq    SoftTurnOffCh2Completed

        lds     Temp, meTurnOffSpeedMode1Ch2
        sbrc    reSystemBits, ebChannel2Mode
        lds     Temp, meTurnOffSpeedMode2Ch2
        inc     rSoftTurnSpeedCh2
        cp      Temp, rSoftTurnSpeedCh2
        brne    ExitSoftTurnOffCh2
        clr     rSoftTurnSpeedCh2
        dec     rBrightnessCh2
  ExitSoftTurnOffCh2:
        rjmp    GoOutCh2

SoftTurnOffCh2Completed:
        cbr     rBit1, 1<<bSoftTurnCh2
        sbrc    rBit1, bTurnOffStartedCh2
        sbr     rBit1, 1<<bIsChannel2On
        ldi     rButton2HoldTime, 255
        rjmp    GoOutCh2

CheckButton2:
        sbic    pKeyboardIn, sbChannel2
        rjmp    Button2IsOff

        ldi     Temp, 255
        sts     mSaveBrightDelayCh2, Temp

        rcall   ResetAutoOffTimerCh2

        cpi     rButton2HoldTime, cButtonOnHoldSense
        breq    Button2OnHold
        cpi     rButton2HoldTime, 255
        breq    PC+2
        inc     rButton2HoldTime
        rjmp    IsChannel2On

Button2OnHold:
        sbrc    rBit1, bTurnOffStartedCh2
        rjmp    RestoreBrightnessCh2
        sbrc    rBit1, bIsChannel2On
        rjmp    ChangeBrightnessCh2

        sbic    pKeyboardIn, sbChannel1
        rjmp    TurnCh2InSecondMode
        mov     Temp, rBit1
        cbr     Temp, (1<<bBrightVectorCh1)+(1<<bBrightVectorCh2)
        brne    TurnCh2InSecondMode
        sbr     reSystemBits, (1<<ebOwnersAtHome)+(1<<ebPowerStateCh1)+(1<<ebPowerStateCh2)
        rcall   OwnersAtHomeTimerTrigger
        rjmp    GoOut

TurnCh2InSecondMode:
        sbr     reSystemBits, 1<<ebChannel2Mode
        cbr     reSystemBits, 1<<ebOwnersAtHome
        rjmp    TurnCh2On

RestoreBrightnessCh2:
        rcall   ResetAutoOffTimerCh2
        cbr     rBit1, 1<<bTurnOffStartedCh2
        sbr     reSystemBits, 1<<ebPowerStateCh2
        sbr     rBit1, 1<<bSoftTurnCh2
        rjmp    GoOutCh2

ChangeBrightnessCh2:
        sbrc    reSystemBits, ebOwnersAtHome
        rjmp    GoOutCh2
        cp      reBrightChangeSpeedCh2, rBrightCounterCh2
        breq    BrightReadyToChangeCh2
        inc     rBrightCounterCh2
        rjmp    IsChannel2On

BrightReadyToChangeCh2:
        clr     rBrightCounterCh2
        sbrc    rBit1, bBrightVectorCh2
        rjmp    IncreaseBrightnessCh2

DecreaseBrightnessCh2:
        lds     Temp, meBrightnessMinCh2
        cp      Temp, rBrightnessCh2
        brsh    MinBrightnessReachedCh2
        dec     rBrightnessCh2
        rjmp    GoOutCh2
  MinBrightnessReachedCh2:
        mov     rBrightCounterCh2, reBrightChangeSpeedCh2
        lds     Temp, mBrightMinCounterCh2
        dec     Temp
        breq    BrightMinTimeoutIsUpCh2
        sts     mBrightMinCounterCh2, Temp
        rjmp    GoOutCh2
  BrightMinTimeoutIsUpCh2:
        lds     Temp, meMinBrightDelayCh2
        sts     mBrightMinCounterCh2, Temp
        sbr     rBit1, 1<<bBrightVectorCh2
        clr     rBrightCounterCh2
        rjmp    GoOutCh2

IncreaseBrightnessCh2:
        lds     Temp, meBrightnessMaxCh2
        cp      rBrightnessCh2, Temp
        brsh    MaxBrightnessReachedCh2
        inc     rBrightnessCh2
        rjmp    GoOutCh2
  MaxBrightnessReachedCh2:
        mov     rBrightCounterCh2, reBrightChangeSpeedCh2
        lds     Temp, mBrightMaxCounterCh2
        dec     Temp
        breq    BrightMaxTimeoutIsUpCh2
        sts     mBrightMaxCounterCh2, Temp
        rjmp    GoOutCh2
  BrightMaxTimeoutIsUpCh2:
        lds     Temp, meMaxBrightDelayCh2
        sts     mBrightMaxCounterCh2, Temp
        cbr     rBit1, 1<<bBrightVectorCh2
        clr     rBrightCounterCh2
        rjmp    GoOutCh2

Button2IsOff:
        cpi     rButton2HoldTime, 255
        brne    PC+2
        ldi     rButton2HoldTime, 0
        cpi     rButton2HoldTime, 0
        breq    IsChannel2On
        cpi     rButton2HoldTime, cButtonOnHoldSense
        ldi     rButton2HoldTime, 0
        breq    HoldButton2

ClickButton2:
        sbrc    rBit1, bIsChannel2On
        rjmp    TurnCh2Off
        cbr     reSystemBits, (1<<ebChannel2Mode)+(1<<ebOwnersAtHome)
        rjmp    TurnCh2On

HoldButton2:
        lds     Temp, meMinBrightDelayCh2
        sts     mBrightMinCounterCh2, Temp
        lds     Temp, meMaxBrightDelayCh2
        sts     mBrightMaxCounterCh2, Temp

        sbrc    reUserBits1, ebBrightDirModeCh2
        rjmp    InvertBrightVectorCh2
        lds     Temp, meBrightnessMinCh2
        cp      rBrightnessCh2, Temp
        breq    InvertBrightVectorCh2
        lds     Temp, meBrightnessMaxCh2
        cp      rBrightnessCh2, Temp
        breq    InvertBrightVectorCh2
        rjmp    IsChannel2On

InvertBrightVectorCh2:
        mov     Temp,   rBit1
        cbr     rBit1, 1<<bBrightVectorCh2
        sbrs    Temp, bBrightVectorCh2
        sbr     rBit1, 1<<bBrightVectorCh2
        rjmp    IsChannel2On

TurnCh2On:
        sbr     rBit1, (1<<bIsChannel2On)+(1<<bSoftTurnCh2)+(1<<bBrightVectorCh2)
        clr     rBrightnessCh2
        rjmp    GoOut

TurnCh2Off:
        sbrs    reSystemBits, ebOwnersAtHome
        rjmp    OwnersAtHomeNotSetCh2
        cbr     rBit1, (1<<bIsChannel1On)+(1<<bIsChannel2On)
        sbr     rBit1, (1<<bSoftTurnCh1)+(1<<bSoftTurnCh2)
        cbr     reSystemBits, (1<<ebOwnersAtHome)+(1<<ebPowerStateCh1)+(1<<ebPowerStateCh2)
        rjmp    GoOutCh2
  OwnersAtHomeNotSetCh2:
        cbr     rBit1, (1<<bIsChannel2On)+(1<<bTurnOffStartedCh2)
        sbr     rBit1, 1<<bSoftTurnCh2
        rjmp    GoOutCh2

IsChannel2On:
        sbrs    rBit1, bIsChannel2On
        rjmp    GoOut

        sbrc    reSystemBits, ebOwnersAtHome
        rjmp    GoOutCh2

        lds     Temp, mSaveBrightDelayCh2
        dec     Temp
        sts     mSaveBrightDelayCh2, Temp
        brne    ExitSaveBrightDelayCh2
        sbrc    rBit1, bTurnOffStartedCh2
        rjmp    ExitSaveBrightDelayCh2
        sbrc    reSystemBits, ebChannel2Mode
        rjmp    SaveBrightnessMode2Ch2
        sbrc    reUserBits2, ebSaveBrightM1Ch2
        sts     meLastBright2_1, rBrightnessCh2
        rjmp    ExitSaveBrightDelayCh2
SaveBrightnessMode2Ch2:
        sbrc    reUserBits2, ebSaveBrightM2Ch2
        sts     meLastBright2_2, rBrightnessCh2
  ExitSaveBrightDelayCh2:

        rcall   TurnOffTimeoutCh2

GoOutCh2:
        ldi     ZH, HIGH(2*BrightnessTable)
        ldi     ZL, LOW(2*BrightnessTable)
        add     ZL, rBrightnessCh2
        ldi     Temp, 0
        adc     ZH, Temp
        lpm     rCh2OffTime, Z

;****************************************    eeprom****************************************
GoOut:
        ldi     Temp, eLastBright1_1    ;     
        lds     Tmp, meLastBright1_1    ;      ,
        rcall   EepromWriteIfDifferent  ;     eeprom.
        ldi     Temp, eLastBright1_2    ;    .
        lds     Tmp, meLastBright1_2
        rcall   EepromWriteIfDifferent
        ldi     Temp, eLastBright2_1    ;    .
        lds     Tmp, meLastBright2_1
        rcall   EepromWriteIfDifferent
        ldi     Temp, eLastBright2_2
        lds     Tmp, meLastBright2_2
        rcall   EepromWriteIfDifferent
        ldi     Temp, eSystemBits       ;       reBit
        mov     Tmp, reSystemBits       ;     eeprom,
        rcall   EepromWriteIfDifferent  ;   reBit  eeprom.

        rjmp    Main
